dojo.require("dojox.grid.DataGrid");
dojo.require("dojo.data.ItemFileWriteStore");
dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("dojo.parser");

// L'id n'est pas éditable !
var layout = [
[
{
    field: "id",
    name: "Id",
    width: 'auto',
    editable: 'false'
},
{
    field: "login",
    name: "Login",
    width: 'auto',
    editable: 'true'
},
{
    field: "lastname",
    name: "Nom",
    width: 'auto',
    editable: 'true'
},
{
    field: "firstname",
    name: "Prénom",
    width: 'auto',
    editable: 'true'
}
]
];
function filtergrid()
{
    var grid = dijit.byId('grid');
    grid.filter({
        id: dojo.byId('search').value + "*"
        });
}
function addgrid()
{
    var item = {
        id: dojo.byId('login').value,
        login : dojo.byId('login').value,
        firstname: dojo.byId('firstname').value,
        lastname: dojo.byId('lastname').value
        };
    var store = dijit.byId("grid").store;

    dojo.xhrPost({
        url: "/user/createjs",
        handleAs: "json",
        headers: {
            "Content-Type" : "application/json"
        },
        postData: dojo.toJson(item),
        handle: function(response, ioargs) {
            var url = ioargs.xhr.getResponseHeader('Location');
            var ident = url.match(/[^\d]*\/(\d+)/)[1];
            switch(ioargs.xhr.status) {
                case 201:
                    var nitem = store.newItem(item);
                    store.setValue(nitem, "id", ident);
                    break;
            }
        }
    });
    dojo.byId('login').value = '';
    dojo.byId('firstname').value = '';
    dojo.byId('lastname').value = '';
    // Rafraichir le contenu de la grille
    loadGrid();
}
function deletegrid()
{
    var grid = dijit.byId('grid');
    var store = grid.store;
    var items = grid.selection.getSelected();
    if(items.length){
        dojo.forEach(items, function(select) {
            if(select !== null) {
                dojo.xhrDelete({
                    url: "/user/id/" + store.getValue(select, "id"),
                    handleAs: 'text',
                    handle: function(error, ioargs) {
                        switch(ioargs.xhr.status) {
                            case 204:
                                store.deleteItem(select);
                        }
                    }
                })
            }
        });
    }
}
function handleResponse(response) {
    var newstore = new dojo.data.ItemFileWriteStore({
        data:

        {
            label: 'name',
            items: response.user
        }
    });
    console.log(newstore);
    var grid = dijit.byId("grid");
    grid.setStore(newstore);
}
function handleError() {
    dojo.debug("Erreur au chargement des données.");
}
function loadGrid() {
    dojo.xhrGet({
        url: "/user/all/",
        //could have been handleAs: "application/xml",
        handleAs: "json",
        // Necessary, otherwise you will always get xml !
        headers: {"Accept": "application/json"},
        load: handleResponse,
        error: handleError
    });
}
function update(e) {
    if(e.keyCode == dojo.keys.ENTER)
    {
        var grid = dijit.byId('grid');
        var store = grid.store;
        var item = grid.getItem(grid.focus.rowIndex);
        var newItem = {
            id: store.getValue(item,"id"),
            login : store.getValue(item,"login"),
            firstname : store.getValue(item,"firstname"),
            lastname : store.getValue(item,"lastname")
        };
        var id = store.getValue(item,"id");

        // Envoi de la requête au ws rest, en PUT. On envoie l'objet en JSon
        dojo.xhrPut({
            url: "/user/id/"+id+"/",
            headers: {
                "Content-Type" : "application/json"
            },
            putData: dojo.toJson(newItem)
        });
        // Note : pas besoin de rafraichir le tableau
    }
}

dojo.addOnLoad(function(){
    dojo.connect(dojo.byId('search'), "onkeyup", filtergrid);
    dojo.connect(dojo.byId('add'), "onclick", addgrid);
    dojo.connect(dojo.byId('delete'), "onclick", deletegrid);
    dojo.connect(dojo.byId('grid'), "onkeypress", update);
    loadGrid();
});