/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package bmserv;

import com.sun.grizzly.http.embed.GrizzlyWebServer;
import com.sun.grizzly.http.servlet.ServletAdapter;
import com.sun.grizzly.tcp.http11.GrizzlyAdapter;
import com.sun.grizzly.tcp.http11.GrizzlyRequest;
import com.sun.grizzly.tcp.http11.GrizzlyResponse;
import com.sun.jersey.spi.container.servlet.ServletContainer;
import java.util.logging.Level;
import java.util.logging.Logger;

import java.io.IOException;

import bmserv.model.Bookmark;
import bmserv.model.Tag;
import bmserv.model.Tagging;
import bmserv.model.User;
import bmserv.model.handlers.BookmarkHandler;
import bmserv.model.handlers.TagHandler;
import bmserv.model.handlers.TaggingHandler;
import bmserv.model.handlers.UserHandler;
import com.sun.grizzly.http.SelectorThread;
import java.util.Scanner;

/**
 *
 * @author michel
 */
public class TestGrizzly {
    /** Gestionnaire de {@link User} */
    static public UserHandler uh = new UserHandler();
    /** Gestionnaire de {@link Tag} */
    static public TagHandler th = new TagHandler();
    /** Gestionnaire de {@link Bookmark} */
    static public BookmarkHandler bmh = new BookmarkHandler();
    /** Gestionnaire de {@link Tagging} */
    static public TaggingHandler tgh = new TaggingHandler();

    public static void main(String[] args) {
            // definition de l'URL de base du serveur et du port a ecouter
    final String baseUri = "http://localhost:9998/";
        Loader.load(); // Chargement des fichiers XML

        GrizzlyWebServer ws = new GrizzlyWebServer(9998, "res");

        // Jersey web resources (rest services)
        ServletAdapter jerseyAdapter = new ServletAdapter();
        jerseyAdapter.addInitParameter("com.sun.jersey.config.property.packages",
                "bmserv.resources");
        jerseyAdapter.setContextPath("/");
        jerseyAdapter.setServletInstance(new ServletContainer());
        ws.addGrizzlyAdapter(jerseyAdapter, new String[]{"/"});

        // Static web resources, html pages, etc. available under /res/home.html etc
        ws.addGrizzlyAdapter(new GrizzlyAdapter() {
            public void service(GrizzlyRequest request, GrizzlyResponse response) {
                try {
                    setHandleStaticResources(true);
                    response.getWriter().println("Le serveur ne trouve pas la ressource demandee, peut-etre que vous venez de lancer le serveur, attendez 3 secondes et faites reload !");
                } catch (IOException ex) {
                    Logger.getLogger(TestGrizzly.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }, new String[]{"/res"});

        try {
                        ws.start();
            SelectorThread threadSelector = ws.getSelectorThread();
            // on lance le serveur
            ServerStateListener ssl = new ServerStateListener(); // Creation d'un listener pour suivre l'etat du serveur
            threadSelector.getController().addStateListener(ssl); // Enregistrement du listener


            // Simulation d'un shell pour le controle du serveur
            String cmd;
            Scanner in = new Scanner(System.in); // scanner de flux d'entree pour lire ce que tape l'utilisateur
            System.out.println("==> Starting grizzly...\n");
            System.out.print(String.format("WADL disponible à l'adresse : %sapplication.wadl", baseUri, baseUri));

            System.out.println("\nCommandes possibles => \"stop|quit|pause|resume\"");

            while (true) {
                System.out.print("\nservershell>");
                cmd = in.nextLine();

                if (cmd.equals("pause")) {
                    System.out.println("==> Server paused...\n");
                    threadSelector.getController().pause(); // pause du serveur
                } else if (cmd.equals("resume")) {
                    System.out.println("==> Server resume...\n");
                    threadSelector.getController().resume(); // reprise du serveur
                } else if (cmd.equals("quit") || cmd.equals("stop")) {
                    threadSelector.getController().stop(); // arret du serveur
                    System.out.println("Bye!\n"); // sortie de l'application
                    break;
                }
            }
            threadSelector.stopEndpoint();
        } catch (IOException ex) {
            System.out.println(ex.getMessage());
        }
    }
}
