package bmserv.resources;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.core.UriBuilder;
import javax.ws.rs.core.UriInfo;

import bmserv.Server;
import bmserv.TemplateEngine;
import bmserv.model.Tagging;

@Path("/tagging")
public class TaggingResource {
	@GET
	@Path("/id/{taggingid}")
	@Produces("text/xml")
	public bmserv.model.Tagging getTaggingFromId(@PathParam("taggingid") String taggingid) {
		Tagging tg = Server.tgh.getTaggingFromId(taggingid);
		return tg;		
	}
	
	@POST
	@Path("/create")
	@Consumes("application/x-www-form-urlencoded")
	@Produces("text/html")
	public String create(@Context HttpServletRequest req, MultivaluedMap<String, String> formParams){
		HttpSession session= req.getSession(true);
		TemplateEngine.setSession(req.getSession());
		String userid = (String) session.getAttribute("userid");
        if (userid!=null) {
                System.out.println(userid);
        		String bmid = formParams.getFirst("bmid");        		
        		List<String> tagids = formParams.get("tagid");  
        		for (String tagid : tagids){
        			Server.tgh.createTagging( userid, bmid, tagid);
        		}        		
        }else{
        	System.out.println("Impossible de créer le tagging, l'utilisateur n'est pas authentifié dans le système.");
        }
        return TemplateEngine.goHome();
	}
	
	@GET
	@Path("/all")
	@Produces("text/xml")
	public bmserv.model.handlers.TaggingHandler getAllTaggings() {
		return Server.tgh;
	}
	
	@Context UriInfo i;
	@GET
	@Path("/all/html")
	@Produces("text/html")	
	public String getAllTaggingsHtml(@Context HttpServletRequest req) {
		
		
		TemplateEngine.setSession(req.getSession());
		final StringBuilder sb = new StringBuilder();
		sb.append("<h1>Taggings</h1>\n<table border='1' cellpadding='2' cellspacing='0' style='margin-top:10px'>");
		List<Tagging> tglist = Server.tgh.getTaggings();
		for (Tagging t : tglist) {
			sb.append("\n<tr id='")
				.append(t.getId())
				.append("'><td><a href='/tag/id/").append(t.getTagId()).append("/html'>")
				.append((Server.th.getTagFromId(t.getTagId())).getLabel())
				.append("</a></td><td><a href='/bookmark/id/").append(t.getBmId()).append("/html'>")
				.append(t.getBmId())
				.append("</a></td><td>")
				.append(t.getAuthorId())
				.append("</td><td>")
				.append(t.getDate())
				.append("</td></tr>");
		}
		sb.append("\n</table>");
		return TemplateEngine.build(sb.toString());
	}	
	
}
